-- Talent check file for the druid class
local class = "DRUID";

-- set up check table
ScrubFork.checks = ScrubFork.checks or { };
ScrubFork.checks[class] = ScrubFork.checks[class] or { };

-- simple function to create new checks
local function check(name, severity, check)
	tinsert(ScrubFork.checks[class], {name=name, severity=severity, check=check});
end

local GREEN = ScrubFork.GREEN;
local YELLOW = ScrubFork.YELLOW;
local RED = ScrubFork.RED;

-- Meta
check("Partial Feral Spec",				RED,	function (talents) return (talents:spent(2) >= 11) and (talents:spent(2) < 41); end);
check("Balance with Feral Talents",		RED,	function (talents) return (talents:spent(1) >= 21) and (talents:spent(2) >  0); end);
check("Feral with Balance Talents",		RED,	function (talents) return (talents:spent(2) >= 21) and (talents:spent(1) > 10); end);

-- Balance
check("Lacking Starlight Wrath",		RED,	function (talents) return (talents:spent(1) >= 21) and (talents:rank(1,  1) < 5); end);
check("No Insect Swarm",				RED,	function (talents) return (talents:spent(1) >= 11) and (talents:rank(1,  8) < 1); end);
check("Lacking Nature's Reach",			YELLOW,	function (talents) return (talents:spent(1) >= 13) and (talents:rank(1,  9) < 2); end);
check("Lacking Lunar Guidance",			YELLOW,	function (talents) return (talents:spent(1) >= 27) and (talents:rank(1, 12) < 3); end);
check("No Nature's Grace",				RED,	function (talents) return (talents:spent(1) >= 21) and (talents:rank(1, 13) < 1); end);
check("Lacking Moonglow",				YELLOW,	function (talents) return (talents:spent(1) >= 24) and (talents:rank(1, 14) < 3); end);
check("Lacking Dreamstate",				RED,	function (talents) return (talents:spent(1) >= 33) and (talents:rank(1, 17) < 3); end);
check("Lacking Moonkin Form",			RED,	function (talents) return (talents:spent(1) >= 34) and (talents:rank(1, 18) < 1); end);
check("Lacking Improved Faerie Fire",	YELLOW,	function (talents) return (talents:spent(1) >= 37) and (talents:rank(1, 19) < 3); end);
-- below from Lorewanderer
check("Lacking Focused Starlight",		RED,	function (talents) return (talents:spent(1) >= 34) and (talents:rank(1, 5) < 2); end);
check("Lacking Vengeance",				RED,	function (talents) return (talents:spent(1) >= 34) and (talents:rank(1, 10) < 5); end);
check("Lacking Moonfury",				RED,	function (talents) return (talents:spent(1) >= 46) and (talents:rank(1, 15) < 5); end);
check("Lacking Balance of Power",		YELLOW,	function (talents) return (talents:spent(1) >= 46) and (talents:rank(1, 16) < 2); end);
check("Lacking Wrath of Cenarius",		RED,	function (talents) return (talents:spent(1) >= 46) and (talents:rank(1, 20) < 5); end);
check("Balance without Imp. MOTW",		YELLOW,	function (talents) return (talents:spent(1) >= 34) and (talents:rank(3, 1) < 5); end);
check("Lacking Subtlety",				YELLOW,	function (talents) return (talents:spent(3) > 13) and (talents:spent(1) > 34) and (talents:rank(3, 7) < 1); end);

-- Feral
check("Lacking Ferocity",				RED,	function (talents) return (talents:spent(2) >=  5) and (talents:rank(2,  1) < 5); end);
check("Lacking Feral Instinct",			RED,	function (talents) return (talents:spent(2) >=  8) and (talents:rank(2,  3) < 3); end);
check("Lacking Thick Hide",				YELLOW,	function (talents) return (talents:spent(2) >= 12) and (talents:rank(2,  5) < 3); end);
check("Lacking Feral Swiftness",		RED,	function (talents) return (talents:spent(2) >= 13) and (talents:rank(2,  6) < 2); end);
check("No Feral Charge",				RED,	function (talents) return (talents:spent(2) >= 11) and (talents:rank(2,  7) < 1); end);
check("Lacking Shredding Attacks",		RED,	function (talents) return (talents:spent(2) >= 18) and (talents:rank(2,  9) < 2); end);
check("Lacking Primal Fury",			RED,	function (talents) return (talents:spent(2) >= 20) and (talents:rank(2, 11) < 2); end);
check("No Faerie Fire (Feral)",			RED,	function (talents) return (talents:spent(2) >= 21) and (talents:rank(2, 13) < 1); end);
check("Nurturing Instinct (PvP)",		YELLOW,	function (talents) return talents:rank(2, 14) > 0; end);
check("Lacking Heart of the Wild",		RED,	function (talents) return (talents:spent(2) >= 30) and (talents:rank(2, 15) < 5); end);
check("Lacking Survival of the Fittest",RED,	function (talents) return (talents:spent(2) >= 34) and (talents:rank(2, 16) < 3); end);
check("No Leader of the Pack",			RED,	function (talents) return (talents:spent(2) >= 31) and (talents:rank(2, 18) < 1); end);
check("Lacking Imp. Leader of the Pack",RED,	function (talents) return (talents:spent(2) >= 36) and (talents:rank(2, 19) < 2); end);
check("Lacking Predatory Instincts",	RED,	function (talents) return (talents:spent(2) >= 40) and (talents:rank(2, 20) < 5); end);
check("No Mangle",						RED,	function (talents) return (talents:spent(2) >= 41) and (talents:rank(2, 21) < 1); end);

-- Restoration
check("Restoration without Imp. MotW",	RED,	function (talents) return (talents:spent(3) >= 21) and (talents:rank(3,  1) < 5); end);
check("Lacking Furor",					RED,	function (talents) return (talents:spent(2) >= 21) and (talents:rank(3,  2) < 5); end);
check("Lacking Naturalist",				RED,	function (talents) return (talents:spent(2) >= 21) and (talents:rank(3,  3) < 5); end);
check("Lacking Intensity",				RED,	function (talents) return (talents:spent(3) >= 21) and (talents:rank(3,  6) < 3); end);
check("No Omen of Clarity",				RED,	function (talents) return (talents:spent(2) >= 21) and (talents:rank(3,  8) < 1); end);
check("Lacking Improved Rejuvenation",	RED,	function (talents) return (talents:spent(3) >= 18) and (talents:rank(3, 10) < 3); end);
check("No Nature's Swiftness",			RED,	function (talents) return (talents:spent(3) >= 21) and (talents:rank(3, 11) < 1); end);
check("Lacking Gift of Nature",			RED,	function (talents) return (talents:spent(3) >= 26) and (talents:rank(3, 12) < 5); end);
check("Lacking Empowered Touch",		YELLOW,	function (talents) return (talents:spent(3) >= 35) and (talents:rank(3, 14) < 2); end);
check("Lacking Improved Regrowth",		YELLOW,	function (talents) return (talents:spent(3) >= 30) and (talents:rank(3, 15) < 5); end);
check("Lacking Living Spirit",			RED,	function (talents) return (talents:spent(3) >= 34) and (talents:rank(3, 16) < 3); end);
check("No Swiftmend",					RED,	function (talents) return (talents:spent(3) >= 31) and (talents:rank(3, 17) < 1); end);
check("Lacking Empowered Rejuvenation",	RED,	function (talents) return (talents:spent(3) >= 40) and (talents:rank(3, 19) < 5); end);
check("No Tree of Life",				RED,	function (talents) return (talents:spent(3) >= 41) and (talents:rank(3, 20) < 1); end);
