-- Talent check file for the mage class
local class = "MAGE";

-- set up check table
ScrubFork.checks = ScrubFork.checks or { };
ScrubFork.checks[class] = ScrubFork.checks[class] or { };

-- simple function to create new checks
local function check(name, severity, check)
	tinsert(ScrubFork.checks[class], {name=name, severity=severity, check=check});
end

local GREEN = ScrubFork.GREEN;
local YELLOW = ScrubFork.YELLOW;
local RED = ScrubFork.RED;

-- Meta

-- Arcane
check("Lacking Arcane Subtlety",		RED,	function (talents) return (talents:spent(1) >= 21) and (talents:rank(1,  1) < 2); end);
check("Partial Imp. Arcane Missiles",	YELLOW,	function (talents) return (talents:rank(1,  3) > 0) and (talents:rank(1,  3) < 5); end);
check("Imp. AM without Emp. AM",		RED,	function (talents) return (talents:rank(1,  3) > 0) and (talents:rank(1, 19) < 3); end);
check("Wand Specialization",			RED,	function (talents) return talents:rank(1,  4) > 0; end);
check("Partial Arcane Concentration",	YELLOW,	function (talents) return (talents:rank(1,  6) > 0) and (talents:rank(1,  6) < 5); end);
check("Partial Arcane Impact",			YELLOW,	function (talents) return (talents:rank(1,  8) > 0) and (talents:rank(1,  8) < 3); end);
check("Arcane Fortitude",			    RED,	function (talents) return talents:rank(1,  9) > 0; end);
check("Partial Improved Counterspell",	YELLOW,	function (talents) return talents:rank(1, 11) == 1; end);
check("Partial Arcane Meditation",		YELLOW,	function (talents) return (talents:rank(1, 12) > 0) and (talents:rank(1, 12) < 3); end);
check("No Presence of Mind",			RED,	function (talents) return (talents:spent(1) >= 21) and (talents:rank(1, 14) < 1); end);
check("Partial Arcane Mind",			YELLOW,	function (talents) return (talents:rank(1, 15) > 0) and (talents:rank(1, 15) < 5); end);
check("Partial Arcane Instability",		YELLOW,	function (talents) return (talents:rank(1, 17) > 0) and (talents:rank(1, 17) < 3); end);
check("Partial Arcane Potency",			YELLOW,	function (talents) return (talents:rank(1, 18) > 0) and (talents:rank(1, 18) < 3); end);
check("No Arcane Power",				RED,	function (talents) return (talents:spent(1) >= 31) and (talents:rank(1, 20) < 1); end);
check("Lacking Spell Power",			YELLOW,	function (talents) return (talents:spent(1) >= 33) and (talents:rank(1, 21) < 2); end);
check("Lacking Mind Mastery",			YELLOW,	function (talents) return (talents:spent(1) >= 40) and (talents:rank(1, 22) < 5); end);

-- Fire
check("Lacking Improved Fireball",		RED,	function (talents) return (talents:spent(2) >= 15) and (talents:rank(2,  1) < 5); end);
check("Impact (PvP)",					YELLOW,	function (talents) return (talents:spent(2) <  46) and (talents:rank(2,  2) > 0); end);
check("Lacking Ignite",					RED,	function (talents) return (talents:spent(2) >= 10) and (talents:rank(2,  3) < 5); end);
check("Lacking Flame Throwing",			YELLOW,	function (talents) return (talents:spent(2) >= 15) and (talents:rank(2,  4) < 2); end);
check("Improved Fire Blast (PvP)",		YELLOW,	function (talents) return (talents:spent(2) <  46) and (talents:rank(2,  5) > 0); end);
check("Lacking Burning Soul",			RED,	function (talents) return (talents:spent(2) >= 21) and (talents:rank(2,  9) < 2); end);
check("Lacking Improved Scorch",		RED,	function (talents) return (talents:spent(2) >= 18) and (talents:rank(2, 10) < 2); end);
check("Improved Fire Ward",				YELLOW,	function (talents) return talents:rank(2, 11) > 0; end);
check("Lacking Master of Elements",		YELLOW,	function (talents) return (talents:spent(2) >= 20) and (talents:rank(2, 12) < 2); end);
check("Blazing Speed (PvP)",			YELLOW,	function (talents) return (talents:spent(2) <  46) and (talents:rank(2, 16) > 0); end);
check("Lacking Fire Power",				RED,	function (talents) return (talents:spent(2) >= 30) and (talents:rank(2, 17) < 5); end);
check("No Combustion",					RED,	function (talents) return (talents:spent(2) >= 31) and (talents:rank(2, 19) < 1); end);
check("Lacking Pyromaniac/Molten Fury",	RED,	function (talents) return (talents:spent(2) >= 36) and ((talents:rank(2, 18) < 3) or (talents:rank(2, 20) < 2)); end);
check("Lacking Empowered Fireball",		RED,	function (talents) return (talents:spent(2) >= 40) and (talents:rank(2, 21) < 5); end);
check("No Dragon's Breath",				YELLOW,	function (talents) return (talents:spent(2) >= 41) and (talents:rank(2, 22) < 1); end);

-- Frost
check("Lacking Improved Frostbolt",		RED,	function (talents) return (talents:spent(3) >= 21) and (talents:rank(3,  2) < 5); end);
check("Lacking Elemental Precision",	RED,	function (talents) return (talents:spent(3) >=  3) and (talents:rank(3,  3) < 3); end);
check("Lacking Ice Shards",				RED,	function (talents) return (talents:spent(3) >= 30) and (talents:rank(3,  4) < 5); end);
check("No Icy Veins",					YELLOW,	function (talents) return (talents:spent(3) <  11) and (talents:rank(3,  9) < 1); end);
check("No Icy Veins",					RED,	function (talents) return (talents:spent(3) >= 11) and (talents:rank(3,  9) < 1); end);
check("Shatter without Ice Shards",		RED,	function (talents) return (talents:rank(3, 13) > 1) and (talents:rank(3,  4) < 5); end);
check("No Cold Snap",					RED,	function (talents) return (talents:spent(3) >= 21) and (talents:rank(3, 15) < 1); end);
check("Low Winter's Chill",				YELLOW,	function (talents) return (talents:spent(3) >= 25) and (talents:rank(3, 18) < 3); end);
check("No Ice Barrier",					YELLOW,	function (talents) return (talents:spent(3) >= 31) and (talents:rank(3, 19) < 1); end);
check("Lacking Empowered Frostbolt",	RED,	function (talents) return (talents:spent(3) >= 40) and (talents:rank(3, 21) < 5); end);
check("No Water Elemental",				RED,	function (talents) return (talents:spent(3) >= 41) and (talents:rank(3, 22) < 1); end);
