-- Talent check file for the priest class
local class = "PRIEST";

-- set up check table
ScrubFork.checks = ScrubFork.checks or { };
ScrubFork.checks[class] = ScrubFork.checks[class] or { };

-- simple function to create new checks
local function check(name, severity, check)
	tinsert(ScrubFork.checks[class], {name=name, severity=severity, check=check});
end

local GREEN = ScrubFork.GREEN;
local YELLOW = ScrubFork.YELLOW;
local RED = ScrubFork.RED;

-- Meta
check("Deep Discipline Spec",			YELLOW,	function (talents) return talents:spent(1) >= 24; end);
check("Partial Shadow Specialization",	RED,	function (talents) return (talents:spent(3) >=  5) and (talents:spent(3) < 41); end);
check("Discipline with Shadow Talents",	RED,	function (talents) return (talents:spent(1) >= 21) and (talents:spent(3) >  0); end);
check("Holy with Shadow Talents",		RED,	function (talents) return (talents:spent(2) >= 21) and (talents:spent(3) >  0); end);
check("Shadow with Holy Talents",		RED,	function (talents) return (talents:spent(3) >= 21) and (talents:spent(2) >  0); end);
check("No Raid Utility",				RED,	function (talents) return (talents:rank(1, 15) < 2) and (talents:rank(2, 21) < 1) and (talents:rank(3, 21) < 1); end);

-- Discipline
check("Wand Specialization",			YELLOW,	function (talents) return talents:rank(1,  2) > 0; end);
check("Lacking Improved PW:Fortitude",	YELLOW,	function (talents) return (talents:spent(1) >= 10) and (talents:rank(1,  4) < 2); end);
check("Martyrdom (PvP)",				YELLOW,	function (talents) return talents:rank(1,  6) > 0; end);
check("No Inner Focus",					RED,	function (talents) return (talents:spent(1) >= 11) and (talents:rank(1,  8) < 1); end);
check("Lacking Meditation",				RED,	function (talents) return (talents:spent(1) >= 14) and (talents:rank(1,  9) < 3); end);
check("Improved Inner Fire (PvP)",		YELLOW,	function (talents) return talents:rank(1, 10) > 0; end);
check("Lacking Mental Agility",			RED,	function (talents) return (talents:spent(1) >= 20) and (talents:rank(1, 11) < 5); end);
check("Improved Mana Burn (PvP)",		YELLOW,	function (talents) return talents:rank(1, 12) > 0; end);
check("No Divine Spirit",				RED,	function (talents) return (talents:spent(1) >= 21) and (talents:rank(1, 14) < 1); end);
check("Lacking Improved Divine Spirit",	RED,	function (talents) return (talents:rank(1, 14) > 0) and (talents:rank(1, 15) < 2); end);
check("Focused Power (PvP)",			YELLOW,	function (talents) return talents:rank(1, 16) > 0; end);
check("Focused Will (PvP)",				RED,	function (talents) return talents:rank(1, 18) > 0; end);
check("No Power Infusion",				RED, 	function (talents) return (talents:spent(1) >= 31) and (talents:rank(1, 19) < 1); end);
check("Reflective Shield (PvP)",		YELLOW,	function (talents) return talents:rank(1, 20) > 0; end);
check("Lacking Enlightenment",			YELLOW,	function (talents) return (talents:spent(1) >= 40) and (talents:rank(1, 21) < 5); end);
check("No Pain Suppression",			RED,	function (talents) return (talents:spent(1) >= 41) and (talents:rank(1, 22) < 1); end);

-- Holy
check("Lacking Healing Focus",			YELLOW,	function (talents) return (talents:spent(2) >=  5) and (talents:rank(2,  1) < 2); end);
check("Lacking Improved Renew",			YELLOW,	function (talents) return (talents:spent(2) >=  5) and (talents:rank(2,  2) < 3); end);
check("Lacking Divine Fury",			RED,	function (talents) return (talents:spent(2) >= 10) and (talents:rank(2,  5) < 5); end);
check("Blessed Recovery (PvP)",			YELLOW,	function (talents) return talents:rank(2,  7) > 0; end);
check("Lacking Inspiration",			YELLOW,	function (talents) return (talents:spent(2) >= 13) and (talents:rank(2,  8) < 3); end);
check("Lacking Improved Healing",		RED,	function (talents) return (talents:spent(2) >= 18) and (talents:rank(2, 10) < 3); end);
check("Searing Light",					RED,	function (talents) return talents:rank(2, 11) > 0; end);
check("No Spirit of Redemption",		RED,	function (talents) return (talents:spent(2) >= 21) and (talents:rank(2, 13) < 1); end);
check("Surge of Light",					RED,	function (talents) return talents:rank(2, 15) > 0; end);
check("Lacking Spiritual Healing",		RED,	function (talents) return (talents:spent(2) >= 30) and (talents:rank(2, 16) < 5); end);
check("Lacking Holy Concentration",		YELLOW,	function (talents) return (talents:spent(2) >= 33) and (talents:rank(2, 17) < 3); end);
check("Blessed Resilience (PvP)",		YELLOW,	function (talents) return talents:rank(2, 19) > 0; end);
check("Lacking Empowered Healing",		RED,	function (talents) return (talents:spent(2) >=  5) and (talents:spent(2) <= 38) and (talents:rank(2, 20) < 3); end)
check("Lacking Empowered Healing",		RED,	function (talents) return (talents:spent(2) >= 39) and (talents:rank(2, 20) < 5); end);
check("No Circle of Healing",			RED,	function (talents) return (talents:spent(2) >= 41) and (talents:rank(2, 21) < 1); end);

-- Shadow
check("Lacking Shadow Affinity",		RED,	function (talents) return (talents:spent(3) >=  8) and (talents:rank(3,  3) < 3); end);
check("Lacking Improved SW:Pain",		RED,	function (talents) return (talents:spent(3) >= 10) and (talents:rank(3,  4) < 2); end);
check("Psychic Scream without Silence", RED,	function (talents) return (talents:rank(3, 6) > 0) and (talents:rank(3, 12) < 1); end);
check("No Mind Flay",					RED,	function (talents) return (talents:spent(3) >= 11) and (talents:rank(3,  8) < 1); end);
check("Improved Fade",					RED,	function (talents) return talents:rank(3,  9) > 0; end);
check("Lacking Shadow Reach",			YELLOW,	function (talents) return (talents:spent(3) >= 20) and (talents:rank(3, 10) < 2); end);
check("Lacking Shadow Weaving",			RED,	function (talents) return (talents:spent(3) >= 18) and (talents:rank(3, 11) < 3); end);
check("No Vampiric Embrace",			RED,	function (talents) return (talents:spent(3) >= 21) and (talents:rank(3, 13) < 1); end);
check("Lacking Focused Mind",			RED,	function (talents) return (talents:spent(3) >= 25) and (talents:rank(3, 15) < 3); end);
check("Shadow Resilience (PvP)",		RED,	function (talents) return talents:rank(3, 16) > 0; end);
check("Lacking Darkness",				RED,	function (talents) return (talents:spent(3) >= 30) and (talents:rank(3, 17) < 5); end);
check("No Shadowform",					RED,	function (talents) return (talents:spent(3) >= 31) and (talents:rank(3, 18) < 1); end);
check("Lacking Misery",					RED,	function (talents) return (talents:spent(3) >= 40) and (talents:rank(3, 20) < 5); end);
check("Lacking Vampiric Touch",			RED,	function (talents) return (talents:spent(3) >= 41) and (talents:rank(3, 21) < 1); end);
