-- Talent check file for the rogue class
local class = "ROGUE";

-- set up check table
ScrubFork.checks = ScrubFork.checks or { };
ScrubFork.checks[class] = ScrubFork.checks[class] or { };

-- simple function to create new checks
local function check(name, severity, check)
	tinsert(ScrubFork.checks[class], {name=name, severity=severity, check=check});
end

local GREEN = ScrubFork.GREEN;
local YELLOW = ScrubFork.YELLOW;
local RED = ScrubFork.RED;

-- Meta
check("Mutilate Spec",					YELLOW,	function (talents) return talents:rank(1, 21) > 0; end);
check("Mutilate w/o Puncturing Wounds", RED,	function (talents) return (talents:rank(1, 21) > 0) and (talents:rank(1,  6) < 3); end);
check("Mutilate without DW spec",		RED,	function (talents) return (talents:rank(1, 21) > 0) and (talents:rank(2,  12) < 5); end);
check("Mutilate with Dagger Spec",		YELLOW,	function (talents) return (talents:rank(1, 21) > 0) and (talents:rank(2, 11) > 0); end);
check("Dagger Spec w/o Imp. Backstab",	RED,	function (talents) return (talents:rank(2, 11) > 0) and (talents:rank(1,  6) < 3); end);
check("Dagger Spec without Opportunity",RED,	function (talents) return (talents:rank(2, 11) > 0) and (talents:rank(3,  2) < 5); end);
check("Shadowstep Spec",				YELLOW,	function (talents) return talents:rank(3, 22) > 0; end);
check("Hemorrhage with Imp Backstab",	YELLOW,	function (talents) return (talents:rank(3, 15) > 0) and (talents:rank(1,  6) > 0); end);
check("Hemorrhage with Improved SS",	YELLOW,	function (talents) return (talents:rank(3, 15) > 0) and (talents:rank(2,  2) > 0); end);
--check("Multiple Weapon Specs",			RED,	function (talents)
--													local dagger = ((talents:rank(2, 11) > 0) and 1) or 0;
--													local mace   = ((talents:rank(2, 13) > 0) and 1) or 0;
--													local sword  = ((talents:rank(2, 15) > 0) and 1) or 0;
--													local fist   = ((talents:rank(2, 16) > 0) and 1) or 0;
--													local hybrid = (((sword == 1) or (fist == 1) or (mace == 1)) and 1) or 0;
--													return dagger + hybrid > 1;
--												end);

-- Assasination
check("Remorseless Attacks",			RED,	function (talents) return talents:rank(1,  2) > 0; end);
check("Lacking Malice",					RED,	function (talents) return talents:rank(1,  3) < 5; end);
check("Lacking Ruthlessness",			RED,	function (talents) return (talents:spent(1) >=  8) and (talents:rank(1,  4) < 2); end);
check("No Relentless Strikes",			RED,	function (talents) return (talents:spent(1) >= 11) and (talents:rank(1,  7) < 1); end);
check("Improved Expose Armor",			YELLOW,	function (talents) return talents:rank(1,  8) > 0; end);
-- check("Lacking Lethality",				RED,	function (talents) return (talents:spent(1) >= 15) and (talents:rank(1,  9) < 4); end);
check("Lacking Murder",					YELLOW,	function (talents) return talents:spent(1) > 13 and talents:rank(1, 5) < 2 end);
check("No Cold Blood",					RED,	function (talents) return (talents:spent(1) >= 21) and (talents:rank(1, 13) < 1); end);
check("Improved Kidney Shot (PvP)",		YELLOW,	function (talents) return talents:rank(1, 14) > 0; end);
check("Lacking Quick Recovery",			YELLOW,	function (talents) return (talents:spent(1) >= 23) and (talents:rank(1, 15) < 2); end);
check("Lacking Seal Fate",				RED,	function (talents) return (talents:spent(1) >= 30) and (talents:rank(1, 16) < 5); end);
check("No Vigor",						RED,	function (talents) return (talents:spent(1) >= 31) and (talents:rank(1, 18) < 1); end);
check("Lacking Find Weakness",			RED,	function (talents) return (talents:spent(1) >= 40) and (talents:rank(1, 20) < 5); end);
check("No Mutilate",					RED,	function (talents) return (talents:spent(1) >= 41) and (talents:rank(1, 21) < 1); end);

-- Combat
check("Lacking Imp. Sinister Strike",	RED,	function (talents) return (talents:rank(3, 15) == 0) and (talents:rank(1, 6) == 0) and (talents:rank(1, 21) == 0) and (talents:rank(2,  2) < 2) end);
check("Partial Imp. Slice and Dice",	YELLOW,	function (talents) return talents:rank(2,  4) < 3; end);
check("Lacking Imp. Slice and Dice",	RED,	function (talents) return talents:rank(2,  4) == 0; end);
check("Lacking Precision",				RED,	function (talents) return talents:rank(2,  6) < 5; end);
check("Partial Dagger Specialization",	YELLOW,	function (talents) return (talents:rank(2, 11) > 0) and (talents:rank(2, 11) < 5); end);
check("Lacking DW Specialization",		RED,	function (talents) return (talents:spent(2) >= 20) and (talents:rank(2, 12) < 5); end);
check("Partial Mace Specialization",	YELLOW,	function (talents) return (talents:rank(2, 13) > 0) and (talents:rank(2, 13) < 5); end);
check("No Blade Flurry",				RED,	function (talents) return (talents:spent(2) >= 21) and (talents:rank(2, 14) < 1); end);
check("Partial Sword Specialization",	YELLOW,	function (talents) return (talents:rank(2, 15) > 0) and (talents:rank(2, 15) < 5); end);
check("Partial Fist Specialization",	YELLOW,	function (talents) return (talents:rank(2, 16) > 0) and (talents:rank(2, 16) < 5); end);
check("Blade Twisting (PvP)",			RED,	function (talents) return talents:rank(2, 17) > 0; end);
check("Lacking Weapon Expertise",		RED,	function (talents) return (talents:spent(2) >= 28) and (talents:rank(2, 18) < 2); end);
check("Lacking Aggression",				YELLOW,	function (talents) return (talents:spent(2) >= 32) and (talents:rank(3, 15) < 1) and (talents:rank(2, 19) < 3); end);
check("No Adrenaline Rush",				RED,	function (talents) return (talents:spent(2) >= 31) and (talents:rank(2, 21) < 1); end);
check("Lacking Combat Potency",			RED,	function (talents) return (talents:spent(2) >= 40) and (talents:rank(2, 23) < 5); end);
check("No Surprise Attacks",			RED,	function (talents) return (talents:spent(2) >= 41) and (talents:rank(2, 24) < 1); end);

-- Subtlety
check("Sleight of Hand (PvP)",			YELLOW,	function (talents) return talents:rank(3,  3) > 0; end);
check("No Ghostly Strike",				YELLOW,	function (talents) return (talents:spent(3) >= 11) and (talents:rank(3,  7) < 1); end);
check("Improved Ambush (PvP)",			YELLOW,	function (talents) return talents:rank(3,  8) > 0; end);
check("Lacking Serrated Blades",		RED,	function (talents) return (talents:spent(3) >= 18) and (talents:rank(3, 11) < 3); end);
check("Heightened Senses (PvP)",		YELLOW,	function (talents) return talents:rank(3, 12) > 0; end);
check("Lacking Dirty Deeds",			RED,	function (talents) return (talents:spent(3) >= 23) and (talents:rank(3, 14) < 2); end);
check("No Hemorrhage",					RED,	function (talents) return (talents:spent(3) >= 21) and (talents:rank(3, 15) < 1); end);
check("Master of Subtlety (PvP)",		RED,	function (talents) return talents:rank(3, 16) > 0; end);
check("Lacking Deadliness",				RED,	function (talents) return (talents:spent(3) >= 30) and (talents:rank(3, 17) < 5); end);
check("Cheat Death (PvP)",				YELLOW,	function (talents) return talents:rank(3, 20) > 0; end);
check("Lacking Sinister Calling",		RED,	function (talents) return (talents:spent(3) >= 40) and (talents:rank(3, 21) < 5); end);
check("No Shadowstep",					RED,	function (talents) return (talents:spent(3) >= 41) and (talents:rank(3, 22) < 1); end);
